
--version
global.mycurrent_version = "Current version: 0051.12.20.101"

function init_vars()

  --GLOBAL SETTINGS
  global.actual_playtime = {}
  global.unlock_itemlist = {}
  global.unlock_itemlist_c = 0
  
  global.ctime_time = 432000 -- 2 hours
  
  global.max_items_unlocks = 200 -- Safty
  
  global.player_afk_threshold = 18000 --5 mins
  global.earlygame_help = 108000 --30 minutes
  
  --tick loop delay--
  global.last_s_tick = 0
  global.s_delay = 120 --2 seconds
  --Debug messages--
  global.debugs = 1
  global.debugs_admin = 1
  --Voteban settings--
  global.voteban_disable = 0
  global.voteban_cooldown = 120 -- Two minutes 
  global.voteban_minvotes = 2 -- Min Votes
  global.voteban_ban_delay = 600 -- 10 seconds
  global.voteban_expires = 2700 -- 45 seconds
  global.voteban_min_for_percent = 7 --min to do percentage voting
  global.numplayers = 0
  global.voteban_percent = 50
  --Permissions settings--
  global.player_probation_time = 10
   
end

-------------------------------------
-- FROM MOD, DONT TOUCH MY STUFF   --
-- Updated and simplified for 0.15 --
-- Original mod used tick timer    --
-- and used a ton of script time   --
-- and didn't unlock items for     --
-- players that left               --
-------------------------------------

-- Replacement handler --
script.on_event(defines.events.on_selected_entity_changed , function(event)

  local player = game.players[event.player_index]
    if ( player and player.valid and player.connected and player.character and player.character.valid ) then
          mine_check(player)
  end
end)

function lock_entity(entity)

  if ( entity == nil ) then
  return
  end
  if ( entity.valid == nil or entity.valid == false ) then
  return
  end
  
  if ( entity.last_user ~= nil ) then
    entity.minable = false
    entity.rotatable = false
    
    if ( global.unlock_itemlist == nil ) then
      global.unlock_itemlist = {}
    end
    if ( global.unlock_itemlist_c == nil ) then
      global.unlock_itemlist_c = 0
    end
    table.insert ( global.unlock_itemlist, entity )
    global.unlock_itemlist_c = ( global.unlock_itemlist_c + 1 )
    --log ( "locking: " .. entity.name )
    --log ( "queue: " .. global.unlock_itemlist_c )
    --log ( "id: " .. entity_id ( entity ) )
  end
end

function unlock_entity(entity)

  if ( entity == nil ) then
  return
  end
  if ( entity.valid == nil or entity.valid == false ) then
  return
  end

	--log ( "unlocking: " .. entity.name )
	--log ( "queue: " .. global.unlock_itemlist_c )
    --log ( "id: " .. entity_id ( entity ) )
    entity.minable = true
    entity.rotatable = true
end

function player_is_entity_owner(player, entity)

  if ( entity == nil ) then
  return
  end
  if ( entity.valid == nil or entity.valid == false ) then
  return
  end

  if ( player and player.valid and player.connected and player.character and player.character.valid ) then
  
     if ( player.permission_group ~= nil ) then
       if ( player.permission_group.name == "Admin" or player.permission_group.name == "Trusted" ) then
         return true
       end
     end
     
    local last_user = entity.last_user
    if last_user and last_user.index ~= player.index then return false else return true end
  end
  
return false
end

function mine_check(player)

    if ( player and player.valid and player.connected and player.character and player.character.valid ) then
    
    local selected = player.selected
    if selected and selected.valid then
        if player_is_entity_owner(player, selected) then
            -- unlock the entity when selected by the owner
            unlock_entity(selected)
        else
            -- lock the entity when selected by a non-owner
            lock_entity(selected)
        end
    end
    
   end
end
script.on_event(defines.events.on_research_finished, function(event)
    local force = event.research.force
    
    game.print ( force.name .. " team completed: " .. event.research.name )
 end)
    
-- Player Creation --
script.on_event(defines.events.on_player_created, function(event)
  
  local player = game.players[event.player_index]
  if ( player and player.valid and player.connected and player.character and player.character.valid ) then
  
    if ( global.actual_playtime == nil or global.actual_playtime[player.index] == nil ) then
      global.actual_playtime[player.index] = player.online_time
    end
  
  
  --Lets get things moving...
  if ( game.tick < global.earlygame_help ) then --First x ticks, players get extra items
  player.insert{name="iron-plate", count=25}
  player.insert{name="copper-plate", count=25}
  player.insert{name="stone", count=25}
  player.insert{name="coal", count=50}
  player.insert{name="pistol", count=1}
  player.insert{name="firearm-magazine", count=25}
  player.insert{name="burner-mining-drill", count = 6}
  player.insert{name="stone-furnace", count = 4}
  player.insert{name="steel-axe", count = 3}
  player.insert{name="transport-belt", count = 50}
  player.insert{name="underground-belt", count = 15}
  player.insert{name="burner-inserter", count = 15}
  else -- After that, they just get basics
  player.insert{name="pistol", count=1}
  player.insert{name="firearm-magazine", count=10}
  player.insert{name="steel-axe", count = 1}
  end
end
  
end)

script.on_event(defines.events.on_player_respawned, function(event)
  local player = game.players[event.player_index]
  if ( player and player.valid and player.connected and player.character and player.character.valid ) then
  
  player.insert{name="pistol", count=1}
  player.insert{name="firearm-magazine", count=10}
  player.insert{name="steel-axe", count = 1}
  
  end
  
end)


script.on_init(function()
  dist_init_voteban(true)
  init_vars()
end)

--Begin DIST--

--Game init--

script.on_load(function()


  if ( commands.commands.server_interface == nil ) then
  
  commands.add_command( "online", "See who is online", function(param)

  
  local numpeople = 0

    local victim = game.players[param.player_index]
    
    if ( victim and victim.valid ) then
    
      for _, player in pairs(game.connected_players) do
      
        if ( player and player.valid and player.connected and player.character and player.character.valid ) then
          numpeople = (numpeople + 1)

           
          admintag = " "
          if ( player.admin ) then
            admintag = "  --  (ADMIN)"
          end
          if ( player.permission_group ~= nil ) then
            if ( player.permission_group.name == "Default" ) then
              admintag = "  --  (NEW)"
            end
          end
        
          if ( global.actual_playtime and global.actual_playtime[player.index] ) then
            victim.print( string.format ( "%-4d: %-8s -- %-32s AFK: %-4d Played: %-4d Online: %-4d%s", numpeople, player.force.name, player.name, math.floor(player.afk_time / 60.0 / 60.0 ),
            math.floor( global.actual_playtime[player.index] / 60.0 / 60.0 ) , math.floor(player.online_time / 60.0 / 60.0 ), admintag ) )
          end    
        end
        
      end
    end

  end)
  
    commands.add_command( "gspeed", "change game speed ( with auto walk speed adjustment )", function(param)
    local player = game.players[param.player_index]
    
    if ( player == nil ) then
      return
    end
      
    if ( player.admin == false ) then
      player.print ( "Nope." )
      return
    end
    
    if ( param.parameter == nil ) then
      return
    end
    
    local value = tonumber ( param.parameter )
    if ( value >= 0.15 and value <= 4.0 ) then
      game.speed = value
      player.force.character_running_speed_modifier = ( (  1.0 / value ) - 1.0 )
      player.print ( "Game speed: " .. value .. " Walk speed: " .. player.force.character_running_speed_modifier )
      game.print ( "(System) Game speed set to %" .. (game.speed * 100.00) )
    else
      player.print ( "That doesn't seem like a good idea..." )
    end
    
    
    end)
  
  commands.add_command( "voteban", "Start or add to a voteban.", function(param)
    local player = game.players[param.player_index]
    
    if ( player and player.valid and player.connected and player.character and player.character.valid ) then
    
      if ( param == nil or param.parameter == nil ) then
        player.print("Usage: /voteban playername -- Votes to ban a player. (Admin: cancel)" )
      return
      end
    
    if ( player.admin and param.parameter == "cancel" and global.voteban_num > 0 ) then
      dist_init_voteban(false)
      game.print ( "(VOTEBAN) Voteban was canceled by an admin." )
      return
    end
    
    if ( global.voteban_disable == 1 ) then
      player.print("Voteban is disabled for the moment." )
      return
    end
    
    if param.parameter then
      local victim = game.players[param.parameter]
      
      if ( victim and victim.valid ) then
            --Go to voteban--
            get_permgroup() --Update permgroups
            if ( victim.permission_group ~= nil ) then
              if ( victim.permission_group.name ~= "Banned" ) then
                dist_voteban_add(player, victim)
              else
                player.print ( "They are already banned..." )
              end
            end
      else
        player.print("No such player... Names are case(capitalization) sensitive. Try tab-complete.")
        message_debug( player.name .. " is trying to voteban " .. param.parameter .. ", but there is no such player." )
      end
    end
    end
  end)
  
  commands.add_command( "tto", "teleport to", function(param)
    local player = game.players[param.player_index]
    
    if ( player and player.valid and player.connected and player.character and player.character.valid ) then
    
      if ( player.admin == false ) then
        player.print ( "No." )
        return
      end
      
      if param.parameter then
        local victim = game.players[param.parameter]
      
        if ( victim and victim.valid ) then
          player.teleport ( victim.position )
          player.print ( "Okay." )
          return
        end
      end
    end
    player.print ( "Error." )
  end)
  
    commands.add_command( "tfrom", "teleport player to me", function(param)
    local player = game.players[param.player_index]
    
    if ( player and player.valid and player.connected and player.character and player.character.valid ) then
    
      if ( player.admin == false ) then
        player.print ( "No." )
        return
      end
      
      if param.parameter then
        local victim = game.players[param.parameter]
      
        if ( victim and victim.valid ) then
          victim.teleport ( player.position )
          player.print ( "Okay." )
          return
        end
      end
    end
    player.print ( "Error." )
  end)
  

  end
  
end)

--Auto permisisons--
function get_permgroup()

    global.trustedgroup = game.permissions.get_group("Trusted")
    global.admingroup = game.permissions.get_group("Admin")
    global.bangroup = game.permissions.get_group("Banned")
    
    if ( global.trustedgroup == nil ) then
      game.permissions.create_group("Trusted")
    end
    
    if ( global.admingroup == nil ) then
      game.permissions.create_group("Admin" )
    end
    
    if ( global.bangroup == nil ) then
      game.permissions.create_group("Banned" )
    end
    
    global.trustedgroup = game.permissions.get_group("Trusted")
    global.admingroup = game.permissions.get_group("Admin")
    global.bangroup = game.permissions.get_group("Banned")

    for _, player in pairs(game.connected_players) do
    if ( player and player.valid and player.connected and player.character and player.character.valid ) then
    
      if (player.admin) then
        if (player.permission_group ~= nil ) then
          if (player.permission_group.name ~= "Admin") then
            global.admingroup.add_player(player)
            message_debug ( player.name .. " moved to admins..." )
          end
        end
        
      else
        if ( global.actual_playtime and global.actual_playtime[player.index] and global.actual_playtime[player.index] > (global.player_probation_time * 60 * 60) ) then
          if ( player.permission_group ~= nil and player.permission_group.name == "Default" ) then
            if ( global.trustedgroup.add_player( player ) ) then
              player.print ( "(SERVER) You have now been playing long enough, that the new-user restrictions on your character have been lifted... Have fun, and be nice!" )
              message_debug ( player.name .. " was moved to trusted users." )
            end
          end
        end
        
      end
  end
  end
end

--Clear voteban--
function dist_init_voteban(boot)

  global.voteban_name = "None"
  global.voteban_age = 0
  global.voteban_num = 0
  
  if ( boot ) then
    global.voteban_last_ban = 0
  else
    global.voteband_last_ban = game.tick
  end
  
  global.voteban_voters = {}
  for x = 0, 1024 do
    global.voteban_voters[x] = "None"
  end
  
end

-- Return a string representing the unique entity id.
-- https://forums.factorio.com/viewtopic.php?f=25&t=32860&sid=a116fe079b1b058b91d496056a1b4fbe
function entity_id(entity)
    if not entity or not entity.valid then return nil end
    return entity.name .. "-" .. entity.position.x .. "-" .. entity.position.y .. "-" .. entity.surface.name .. "-"
end

--Tick loop--
--Keep to minimum--
script.on_event(defines.events.on_tick, function(event)

if ( global.old_version ~= global.mycurrent_version or global.old_version == nil ) then
	init_vars()
	dist_init_voteban(true)
	global.old_version = global.mycurrent_version
end

if (game.tick - global.last_s_tick >= global.s_delay) then
    get_permgroup()
    dist_check_voteban()
    
    global.numplayers = 0
    
        for _, player in pairs(game.connected_players) do
      if ( player and player.valid and player.character and player.character.valid and player.connected ) then
      
      -- Actual playtime
      if ( global.actual_playtime == nil or global.actual_playtime[player.index] == nil ) then
        global.actual_playtime[player.index] = player.online_time
      end
      
        if ( player.afk_time < global.player_afk_threshold ) then
          global.numplayers = ( global.numplayers + 1 )
          
          if ( global.actual_playtime and global.actual_playtime[player.index] ) then
            global.actual_playtime[player.index] = ( global.actual_playtime[player.index] + ( global.s_delay - 1 ) )
          end
          
        end
      end
    end

    
local is_select = false
    
    if ( global.unlock_itemlist == nil ) then
      global.unlock_itemlist = {}
    end
    if ( global.unlock_itemlist_c == nil ) then
      global.unlock_itemlist_c = 0
    end
    
    if ( global.unlock_itemlist ) then
    for x, item in pairs ( global.unlock_itemlist ) do
    
    --Sane limit
    if ( x > global.max_items_unlocks ) then
      break;
    end
    is_select = false
    if ( item ) then
    
     for _, player in pairs(game.connected_players) do
      if ( player and player.valid and player.character and player.character.valid and player.connected ) then
        if ( player.selected and player.selected.valid ) then
          if ( item and item.valid and entity_id ( item )  == entity_id (player.selected ) ) then
            is_select = true
            --game.print ( entity_id (item) )
          end
        end
      end
    end
    
    if ( is_select == false ) then
      if ( item and item.valid ) then
        unlock_entity ( item )
      end
      --log ( "Removing: " .. entity_id ( global.unlock_itemlist[x] ) );
      table.remove ( global.unlock_itemlist, x )
      global.unlock_itemlist_c = ( global.unlock_itemlist_c - 1 )
    end
    

  end
  end
  end
    
    if ( global.unlock_itemlist_c > 50 ) then
      log ( "Item unlock queue: " .. global.unlock_itemlist_c )
    end
    
    global.last_s_tick = game.tick
  end
    
end)


-- Main voteban command --
function dist_voteban_add(player, victim)

  if ( player == nil or player.permission_group == nil ) then
    message_debug ( "voteban invalid player user or group" )
    return
  end
  
  if ( victim == nil or victim.permission_group == nil ) then
    message_debug ( "voteban invalid victim user or group" )
    return
  end
  
  if ( player and player.valid and player.character and player.character.valid and player.connected ) then
  if ( victim and victim.valid ) then
  if ( player.permission_group.name == "Trusted" or player.permission_group.name == "Admin" ) then
  
    if ( global.voteban_name ~= victim.name and global.voteban_name ~= "None" ) then
      player.print ( "You cant vote to ban someone else, until the current voteban completes or expires." )
    return
    end
    if ( ( game.tick - global.voteban_last_ban ) < global.voteban_cooldown ) then
      player.print ( "Last voteban was only " .. ( game.tick - global.voteban_last_ban ) .. " seconds ago... You will have to wait a while longer." )
      message_debug ( player.name .. " tried to voteban " .. victim.name .. " but it hasnt been long enough since last voteban yet." )
      return
    end
    if ( victim.admin == true ) then
      player.print ( "You can't ban admins..." )
      message_debug ( player.name .. " tried to voteban admin " .. victim.name )
      return
    end
    
    if ( global.voteban_voters == nil ) then
      message_debug ( player.name .. " voted but voteban_voters was nil." )
      dist_init_voteban(false)
      return
    end
    
    for _, check_player in pairs(global.voteban_voters) do
      if ( check_player == nil ) then
        return
      end
      if ( check_player == player.name ) then
        player.print ( "You already voted..." )
        message_debug ( player.name .. " tried to voteban, but had already voted..." )
        return
      end
    end
    
      global.voteban_name = victim.name
      global.voteban_age = game.tick
      global.voteban_num = (global.voteban_num + 1)             
      
      if ( global.numplayers >= global.voteban_min_for_percent ) then
        if ( global.voteban_num > 0 and (global.voteban_num / global.numplayers * 100 ) > global.voteban_percent ) then
          player.print ( "Already enough votes..." )
          message_debug ( player.name .. " was late to the vote." )
          return
        end
      else
        if ( global.voteban_num > global.voteban_minvotes ) then
          player.print ( "Already enough votes..." )
          message_debug ( player.name .. " was late to the vote." )
          return
        end
      end
        
      global.voteban_voters[global.voteban_num] = player.name
      local percent_message = " "
      if ( global.voteban_num > 0 and global.numplayers >= global.voteban_min_for_percent  ) then
        percent_message = ("[%" .. math.floor(global.voteban_num / global.numplayers * 100 ).."] (%" .. global.voteban_percent .. " needed)" )
      end
      game.print ( "(VOTEBAN) " .. player.name .. " voted to ban " .. victim.name .. ". [ " .. global.voteban_num .." vote(s) ] " .. percent_message)
      return
  end
  
  player.print ( "Voteban is for trusted users, and admins only..." )
  message_debug ( player.name .. " tried to use voteban, but isnt eligible." )
  return
  end
  end
end


--Main voteban loop--
function dist_check_voteban()
  if ( ( game.tick - global.voteban_age ) > global.voteban_expires and global.voteban_num > 0 ) then
    dist_init_voteban(false)
    game.print ( "(VOTEBAN) Voteban expired... Not enough votes." )
  end
  if ( global.voteban_name == nil or global.voteban_name == "None" ) then
    return
  end
  
  local percent_reached = false
  
  if ( global.numplayers >= global.voteban_min_for_percent ) then
    if ( math.floor(global.voteban_num / global.numplayers * 100 ) > global.voteban_percent ) then
      percent_reached = true
    end
  elseif ( global.numplayers < global.voteban_min_for_percent and global.voteban_num > global.voteban_minvotes ) then
    percent_reached = true
  end
  
  if ( percent_reached ) then
    if ( ( game.tick - global.voteban_age ) > ( global.voteban_ban_delay ) and global.voteban_name ~= nil and global.voteban_name ~= "None" ) then
      local victim = game.players[global.voteban_name]  
      if ( victim and victim.valid and victim.permission_group ) then
        if ( global.bangroup.add_player(victim) == true ) then
          game.print ( "(VOTEBAN) Votes reached... Banning " .. global.voteban_name .. "..." )
          dist_init_voteban(false)
        else
          game.print ( "(VOTEBAN) Votes reached... But there was an error attempting to ban " .. global.voteban_name .. "..." )
          dist_init_voteban(false)
        end
      end
    end
  end
end


--User login--
script.on_event(defines.events.on_player_joined_game, function(event)

local player = game.players[event.player_index]

if ( player and player.valid and player.connected and player.character and player.character.valid ) then
  
  if ( global.actual_playtime == nil or global.actual_playtime[player.index] == nil ) then
    global.actual_playtime[player.index] = player.online_time
  end
  
  player.print("/online to see users online" )
  player.print("/voteban username to ban a user" )
  player.print("Discord server: discord.gg/HYCayGz" )
  player.print("Your player will be restricted, until you play for a while." )
end

end)

--Debug messages--
function message_admins(message)
for _, player in pairs(game.connected_players) do
  if ( player and player.valid and player.connected and player.character and player.character.valid ) then
    if ( player.admin ) then
      player.print(message)
    end
  end
end
end

function message_debug(message)
if ( global.debugs == 0 ) then
  return
end

if ( global.debugs_admin == 1 ) then
  message_admins( "(INFO) " .. message)
  return
end

for _, player in pairs(game.connected_players) do
  if ( player and player.valid and player.connected and player.character and player.character.valid ) then
    if (player.name == "Distortions864") then
      player.print( "(INFO) " .. message)
      return
    end
  end
end
end



